<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: config.php,v 1.26 2004/05/11 13:22:24 lseeker Exp $
 */

require 'lib/common.php';
require 'lib/article.basic.php';
require 'lib/article.write.php';

$Config->checkAdmin();

$Layout = new Layout;
$Layout->hideInclude();
$Layout->hideHeadText();
$Layout->printHeader();

$DBConn = new DBConnection;
$dbms =& $DBConn->getVersion();
delete($DBConn);
DBConnectionFinish();

$htmltag = $autolink = $md5check = '';
if ($Config->htmltag)  $htmltag  = ' checked="checked"';
if ($Config->autolink) $autolink = ' checked="checked"';
if ($Config->md5check) $md5check = ' checked="checked"';

$from = empty($_GET['from']) ? 'list.php' : htmlspecialchars($_GET['from']);
// {{{ CONFIG HTML
?>
<h1 class="center">EtchiBBS 환경 설정</h1>
<p class="center">
 [ <a href="uninstall.php"><span class="fgSpc2">설치 제거</span></a> ]
 [ <a href="<?php echo $from; ?>"><span class="fgSpc1">돌아가기</span></a> ]
<form method="post" action="config_ok.php" onsubmit="return checkform_config(this);">
 <div id="hbConfig">
  <div class="hbTitle bgTitle">환경 설정</div>
  <input type="hidden" name="from" value="<?php echo $from; ?>">
  <table width="100%" cellspacing="1" cellpadding="2">
   <tr>
    <th>관리자 비밀번호</th>
    <td>
     - 관리자 비밀번호는 게시물 수정/변경/삭제, 관리자 모드, 아이콘 업로드에 사용됩니다.<br />
     - 분실되거나 노출되지 않도록 주의해주세요.<br />
     <span class="black">마스터 비밀번호)
      <input type="password" maxlength="30" size="10" name="admin_pass" />
      확인 입력) <input type="password" maxlength="30" size="10" name="admin_pass_confirm" />
     </span>
     <span class="red">(변경시에만 입력)</span>
    </td>
   </tr>
   <tr>
    <th>페이지 상단 글씨<br /><span class="nobold">(HTML 태그로 입력)</span></th>
    <td>
     - 아무것도 넣지 않을 경우 페이지 상단에는 글씨가 뜨지 않습니다.<br />
     <textarea name="title_text" rows="7" cols="63"><?php echo $Config->html_head; ?></textarea>
    </td>
   </tr>
   <tr>
    <th>배경 그림</th>
    <td>
     - 페이지 배경 그림의 주소를 적어주세요. (바둑판식 적용)<br />
     <input type="text" name="bgimage" size="64" value="<?php echo $Config->bg_image; ?>" maxlength="255">
    </td>
   </tr>
   <tr>
    <th>페이지당 게시물 수</th>
    <td>
     - 한 페이지에 보여지는 글 수입니다. 1부터 99까지 지정하실 수 있습니다.<br />
     <input type="text" name="article_per_page" size="14" maxlength="2" value="<?php echo $Config->app; ?>" class="center" /> 개
    </td>
   </tr>
   <tr>
    <th>게시판 스킨</th>
    <td>
     - 게시판의 모양을 사용자 정의할 수 있습니다.<br />
     <select name="board_skin">
      <option value="<?php echo $Config->skin; ?>" selected="selected">현재 설정: <?php echo $Config->skin; ?></option>
<?php
if ($handle = opendir('skin/')) {
    while (false !== ($file = readdir($handle))) { 
        if (is_dir('skin/' . $file) && $file != '.' && $file != '..') { 
            echo "<option value=\"{$file}\">{$file}</option>\n"; 
        }
    }
    closedir($handle); 
}
?>
     </select>
    </td>
   </tr>
   <tr>
    <th>최대 업로드 크기</th>
    <td>
     - 업로드되는 그림의 크기가 너무 클 경우를 대비하여, 제한을 두는 기능입니다.<br />
     - 0은 PHP 업로드 크기 제한입니다. (<span class="red"><?php echo ini_get('upload_max_filesize'); ?></span>)<br />
     - 바이트 단위로 기재하여 주십시오.<br />
     <span class="black">
      <input type="text" name="fileup_max" size="14" value="<?php echo $Config->filesize_max; ?>" class="center" />
      byte(s)
     </span>
    </td>
   </tr>
   <tr>
    <th>HTML 태그 허용</th>
    <td>
     - 목록에 게시물 내용이나 의견글을 표시할 때, HTML 태그의 허용 여부를 결정합니다.<br />
     <span class="black">
      <input type="checkbox" name="htmltag" value="t" <?php echo $htmltag; ?> />게시물/의견글에 HTML 태그 허용
     </span>
    </td>
   </tr>
   <tr>
    <th>게시판 상단 파일</th>
    <td>
     - 게시판의 상단에 포함할 (include) HTML 파일을 지정합니다.<br />
     - body, head 등의 태그는 여기에 지정한 파일의 값을 우선으로 처리합니다.<br />
     <input type="text" name="include_up" size="64" value="<?php echo $Config->file_head; ?>" maxlength="255" />
    </td>
   </tr>
   <tr>
    <th>게시판 하단 파일</th>
    <td>
     - 게시판의 하단에 포함할 (include) HTML 파일을 지정합니다.<br />
     <input type="text" name="include_bt" size="64" value="<?php echo $Config->file_foot; ?>" maxlength="255" />
    </td>
   </tr>
   <tr>
    <th>게시판 타이틀</th>
    <td>
     - 웹브라우저의 제목 표시줄에 표시할 텍스트입니다.<br />
     - 아무것도 입력하지 않으시면 기본값을 사용합니다. (EtchiBBS <?php echo __VERSION__; ?> :: 경로)<br />
     <input type="text" name="titlebar" size="32" value="<?php echo $Config->html_title; ?>" maxlength="255" />
    </td>
   </tr>
   <tr>
    <th>그림 크기 조절</th>
    <td>
     - 그림의 가로(width)크기가 아래 수치를 넘으면 자동으로 아래 크기로 리사이징합니다.<br />
     - 0은 리사이징을 하지 않습니다. (권장 - 리사이징시 그림이 깨질 수 있습니다)<br />
     <span class="black">
      <input type="text" name="width_max" size="14" maxlength="4" value="<?php echo $Config->imgwidth_max; ?>" class="center" />
      픽셀 이상의 가로 크기는 현재 수치로 재조절 (가로/세로 비율 고정)
     </span>
    </td>
   </tr>
   <tr>
    <th>자동 링크 기능</th>
    <td>
     - 게시물 내부에 있는 웹사이트 주소를 자동으로 링크로 처리해주는 기능입니다.<br />
     <span class="black">
      <input type="checkbox" name="autolink" value="t" <?php echo $autolink; ?> />사용함
     </span>
    </td>
   </tr>
   <tr>
    <th>파일 중복 체크</th>
    <td>
     - 첨부된 그림의 md5값을 추출하여 이미 올라온 적이 있는 그림인지를 검사해 줍니다.<br />
     - 게시판에 약간의 성능 저하가 있을 수 있습니다. (글 작성시)<br />
     <span class="black">
      <input type="checkbox" name="md5check" value="t" <?php echo $md5check; ?> />사용함
     </span>
    </td>
   </tr>
   <tr>
    <th>파일 종류 제한</th>
    <td>
     - 그림 파일의 종류를 제한합니다.<br />
     <span class="black">
      <input type="radio" name="filetypes[]" value="<?php echo FILETYPE_CHECK; ?>"<?php if ($Config->allow_filetype & FILETYPE_CHECK) echo 'checked="checked"'; ?> />사용함
      <input type="radio" name="filetypes[]" value="0"<?php if (!($Config->allow_filetype & FILETYPE_CHECK)) echo 'checked="checked"'; ?> />사용하지 않음<br />
      <input type="checkbox" name="filetypes[]" value="<?php echo FILETYPE_GIF; ?>"<?php if ($Config->allow_filetype & FILETYPE_GIF) echo 'checked="checked"'; ?> />GIF
      <input type="checkbox" name="filetypes[]" value="<?php echo FILETYPE_JPG; ?>"<?php if ($Config->allow_filetype & FILETYPE_JPG) echo 'checked="checked"'; ?> />JPG
      <input type="checkbox" name="filetypes[]" value="<?php echo FILETYPE_PNG; ?>"<?php if ($Config->allow_filetype & FILETYPE_PNG) echo 'checked="checked"'; ?> />PNG
      <input type="checkbox" name="filetypes[]" value="<?php echo FILETYPE_BMP; ?>"<?php if ($Config->allow_filetype & FILETYPE_BMP) echo 'checked="checked"'; ?> />BMP
      <input type="checkbox" name="filetypes[]" value="<?php echo FILETYPE_TIFF; ?>"<?php if ($Config->allow_filetype & FILETYPE_TIFF) echo 'checked="checked"'; ?> />TIFF
      <input type="checkbox" name="filetypes[]" value="<?php echo FILETYPE_UNKNOWN; ?>"<?php if ($Config->allow_filetype & FILETYPE_UNKNOWN) echo 'checked="checked"'; ?> />UNKNOWN
     </span>
    </td>
   </tr>
   <tr>
    <th>시스템 정보</th>
    <td>
     - HTTP Server: <?php echo $_SERVER['SERVER_SOFTWARE']; ?><br />
     - Hostname: <?php echo $_SERVER['HTTP_HOST']; ?><br />
     - PHP Version: <?php echo phpversion(); ?><br />
     - Database: <?php echo $dbms; ?>
    </td>
   </tr>
   <tr>
    <th colspan="2">
     <input accesskey="s" type="submit" value="설정 저장(Alt+S)" />
     <input accesskey="r" type="reset" value="다시 작성(Alt+R)" />
    </td>
   </tr>
  </table>
 </div>
</form>
<?php
// }}}
$Layout->printFooter();
?>
