<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: config_ok.php,v 1.29 2004/04/04 23:26:40 lseeker Exp $
 */

require 'lib/common.php';

$Config->checkAdmin();

$article_per_page    = (int) $_POST['article_per_page'];
if ($article_per_page < 1 || $article_per_page > 99) trigger_error('페이지당 글 수가 범위를 초과했습니다.', E_USER_ERROR);

$width_max = (int) $_POST['width_max'];
if ($width_max < 0 || $width_max > 9999) trigger_error('이미지 너비 제한이 범위를 초과했습니다.', E_USER_ERROR);

$allow_filetype = (int) array_sum($_POST['filetypes']);

$width_max = ($width_max << 10) | $allow_filetype;

/* 비밀번호 확인, 비번이 비어있다면 현재 비번으로 그냥 처리 */
if (strcmp($_POST['admin_pass'], '')) {
    mt_srand(microtime() * 1e6);
    $salt = chr(mt_rand(0x21, 0x7E)) . chr(mt_rand(0x21, 0x7E));
    $admin_pass =& quote_string(crypt($_POST['admin_pass'], $salt));
    /* 비번 변경시 쿠키를 다시 구워줌 */
    setcookie('hboard_admin_login', $admin_pass); // 관리자 쿠키 넣어주기
} else {
    $admin_pass =& quote_string($Config->password);
}

$_POST['fileup_max'] = (int) $_POST['fileup_max'];

$_POST['title_text'] =& quote_string($_POST['title_text']);
$_POST['board_skin'] =& quote_string($_POST['board_skin']);
$_POST['include_up'] =& quote_string($_POST['include_up']);
$_POST['include_bt'] =& quote_string($_POST['include_bt']);
$_POST['bgimage']    =& quote_string($_POST['bgimage']);
$_POST['titlebar']   =& quote_string($_POST['titlebar']);

$htmltag = $autolink = $md5check = 'f';
if (isset($_POST['htmltag']))  $htmltag  = 't';
if (isset($_POST['autolink'])) $autolink = 't';
if (isset($_POST['md5check'])) $md5check = 't';

$DBConn = new DBConnection;
$DBConn->exec("UPDATE hboard_db_admin SET passwd='{$admin_pass}',
        title_text='{$_POST['title_text']}',
        app=app+{$article_per_page}-{$Config->app},
        skin='{$_POST['board_skin']}',
        fileup_max={$_POST['fileup_max']},
        html_tag='{$htmltag}',
        include_top='{$_POST['include_up']}', include_bottom='{$_POST['include_bt']}',
        bgimage='{$_POST['bgimage']}',
        width_max={$width_max},
        titlebar='{$_POST['titlebar']}',
        autolink='{$autolink}', backdrum='{$md5check}'");

// 처리 끝
$redirect_to = empty($_POST['from']) ? 'list.php' : $_POST['from'];
include 'lib/redirect.php';
?>
