<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: del_article.php,v 1.36 2004/05/11 13:22:24 lseeker Exp $
 */

require 'lib/common.php';

$Layout = new Layout;
$Layout->hideInclude();

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
    // {{{ NOT POST -> 확인
    include 'lib/confirmbox.php';

    if (empty($_GET['article'])) trigger_error('삭제할 글 번호를 입력해주세요.', E_USER_WARNING);

    $ConfirmBox = new ConfirmBox;
    $ConfirmBox->registerAction('del_article.php');
    $ConfirmBox->registerValues($_GET['page'], $_GET['article']);

    if ($Config->checkAdmin) {
        $ConfirmBox->hidePasswordInput();
        $ConfirmBox->registerMessage(intval($_GET['article']) . '번 게시물을 정말로 삭제하시겠습니까?');
    } else {
        $ConfirmBox->registerMessage('게시물 작성시 넣으셨던 비밀번호를 입력하세요.');
    }

    $Layout->printHeader();
    $ConfirmBox->printOut();
    $Layout->printFooter();
    // }}}
    exit;
}

// POST -> 삭제실행
if (empty($_POST['article'])) trigger_error('삭제할 게시물이 지정되지 않았습니다.', E_USER_WARNING);

require 'lib/article.basic.php';
// {{{ ArticleDelete class
class ArticleDelete extends ArticleBasic
{
    function remove()
    {
        ignore_user_abort(TRUE);

        $DBConn = new DBConnection;
        $DBConn->begin();

        $DBConn->exec('UPDATE hboard_db_article SET deleted=\'t\' WHERE idx=' . $this->no);
        $DBConn->exec('UPDATE hboard_db_admin SET app=app+100');
        $this->image->remove();

        $DBConn->commit();
    }
}
// }}}

$Article = new ArticleDelete((int) $_POST['article']);

$Article->checkDeleted();
if (!$Config->checkAdmin) $Article->checkPassword($_POST['password']);

$Article->remove();

// Output
$MessageBox = new MessageBox;
$MessageBox->setTypeList((int) $_POST['page'], $Article->no);
$MessageBox->registerTitle('안내');
$MessageBox->registerMessage("{$Article->no}번 게시물을 삭제하였습니다.");

$Layout->printHeader();
$MessageBox->printOut();
$Layout->printFooter();

?>
