<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: del_comment.php,v 1.27 2004/05/11 13:22:24 lseeker Exp $
 */

require 'lib/common.php';

$Layout = new Layout;
$Layout->hideInclude();

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
    // {{{ NOT POST - 확인
    include 'lib/confirmbox.php';

    if (empty($_GET['article']) || empty($_GET['num'])) trigger_error('삭제할 의견글을 입력해주세요.', E_USER_WARNING);

    $ConfirmBox = new ConfirmBox;
    $ConfirmBox->registerAction('del_comment.php');
    $ConfirmBox->registerValues((int) $_GET['page'], (int) $_GET['article'], (int) $_GET['num']);

    if ($Config->checkAdmin) {
        $ConfirmBox->hidePasswordInput();
        $ConfirmBox->registerMessage('선택하신 의견글을 정말로 삭제하시겠습니까?');
    } else {
        $ConfirmBox->registerMessage('의견글 작성시 넣으셨던 비밀번호를 입력하세요.');
    }

    $Layout->printHeader();
    $ConfirmBox->printOut();
    $Layout->printFooter();
    // }}}
    exit;
}

// POST :: 삭제 실행
if (empty($_POST['article']) || empty($_POST['num'])) trigger_error('삭제될 의견글이 지정되지 않았습니다.', E_USER_WARNING);

require 'lib/reply.php';
// {{{ ReplyDelete class
class ReplyDelete extends ReplyBasic
{
    function checkDeleted()
    {
        if ($this->deleted) trigger_error('이미 삭제된 의견글입니다.', E_USER_WARNING);
    }

    function checkPassword(&$pass)
    {
        if(empty($pass) || $this->password != crypt($pass, $this->password)) trigger_error('비밀번호가 올바르지 않습니다.', E_USER_WARNING);
    }

    function remove()
    {
        $DBConn = new DBConnection;
        $DBConn->exec("UPDATE hboard_db_comment set deleted='t' WHERE article={$this->no} and idx={$this->rno}");
    }
}
// }}}

$Reply = new ReplyDelete((int) $_POST['article'], (int) $_POST['num']);
$Reply->checkDeleted();
if (!$Config->checkAdmin) $Reply->checkPassword($_POST['password']);
$Reply->remove();

/* completed */
$MessageBox = new MessageBox;
$MessageBox->setTypeList((int) $_POST['page'], $article_no);
$MessageBox->registerTitle('안내');
$MessageBox->registerMessage("{$Reply->no}번 게시물의 {$Reply->rno}번째 의견글을 삭제했습니다.");

$Layout->printHeader();
$MessageBox->printOut();
$Layout->printFooter();

?>
