<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: article.basic.php,v 1.7 2004/04/04 23:42:14 lseeker Exp $
 */

// {{{ ImageBasic
class ImageBasic {
    var $file;
    var $name;
    var $width;
    var $height;
    var $type;
    var $md5;
    var $size;

    var $maxwidth = 0;

    function ImageBasic($file)
    {
        if (!file_exists($file)) {
            trigger_error("{$file} 파일이 없습니다.", E_USER_NOTICE);
            return;
        }

        $this->file = $file;
        $this->name = basename($file);
        list($this->width, $this->height, $this->type, $dummy) = getimagesize($file);
        $this->md5  = md5_file($file);
        $this->size = filesize($file);
    }

    function remove()
    {
        $DBConn = new DBConnection;
        $DBConn->exec("UPDATE hboard_db_admin SET article_max=article_max-{$this->size}");

        unlink($this->file);
    }

    function setMaxWidth(&$width)
    {
        $this->maxwidth =& $width;
    }

    function printOut()
    {
        if ($this->maxwidth && $this->width > $this->maxwidth) {
            $width  = $this->maxwidth;
            $height = (int) ($this->height / $this->width * $this->maxwidth);
            $alt    = "{$this->name}: {$width}x{$height}(으)로 크기 조정 (원래 크기 {$this->width}x{$this->height}) - 클릭하시면 새 창으로 원래 크기의 그림을 표시합니다.";
        } else {
            $width  = $this->width;
            $height = $this->height;
            $alt    = "{$this->name}: ({$width}x{$height}) - 클릭하시면 새 창으로 그림을 표시합니다.";
        }

        echo "<div class=\"hbImage\"><a href=\"{$this->file}\" target=\"_blank\" title=\"{$alt}\"><img src=\"{$this->file}\" width=\"{$width}\" height=\"{$height}\" alt=\"{$alt}\" /></a></div>\n";
    }
}
// }}}

// {{{ ArticleBasic
class ArticleBasic
{
    var $no = 0;

    var $name;
    var $email;
    var $homepage;
    var $date;

    var $subject;
    var $content;
    var $image;

    var $ipaddress;
    var $useragent;

    var $deleted;
    var $replies;
    var $password;

    function ArticleBasic($no = NULL)
    {
        if ($no === NULL) return;

        $DBConn = new DBConnection;

        $Result =& $DBConn->query('SELECT idx, name, email, home, ipaddr, passwd, date, cfile, subject, ment, deleted, reply, agent FROM hboard_db_article WHERE idx=' . $no);
        if (!$Result) trigger_error('해당하는 게시물이 없습니다.', E_USER_WARNING);

        $this->attach($Result);
        delete($Result);
    }

    function attach(&$Result)
    {
        $this->no = (int) $Result->getValue('idx');

        $this->name     =& $Result->getValue('name');
        $this->email    =& $Result->getValue('email');
        $this->homepage =& $Result->getValue('homepage');
        $this->date     =& $Result->getValue('date');

        $this->subject =& $Result->getValue('subject');
        $this->content =& $Result->getValue('ment');

        $this->ipaddress =& $Result->getValue('ipaddr');
        $this->useragent =& $Result->getValue('agent');

        $this->deleted  = $Result->getValue('deleted') == 't' ? TRUE : FALSE;
        if (!$this->deleted) $this->image = new ImageBasic('db/img/' . $Result->getValue('cfile'));
        $this->replies  = (int) $Result->getValue('reply');
        $this->password =& $Result->getValue('passwd');
    }

    function checkDeleted()
    {
        if ($this->deleted) trigger_error('삭제된 글입니다.', E_USER_WARNING);
    }

    function checkPassword(&$new_password)
    {
        if (empty($new_password) || $this->password != crypt($new_password, $this->password)) trigger_error('비밀번호가 올바르지 않습니다.', E_USER_WARNING);
    }
}
// }}}

?>
