<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: article.print.php,v 1.14 2004/05/15 16:34:27 lseeker Exp $
 */

require 'lib/reply.php';

function &AutoLink(&$ment) {
    // 주소 자동링크 function
    /* URL reference: RFC 1738 */
    return ereg_replace("[a-z0-9+.-]+:(//)?([a-z0-9&-.!\$;=?\\\\_]+(:[a-z0-9&-.!\\\$;=?\\\\_]+)?@)?[[:alnum:]\200-\377.%-]+(:[[:digit:]]+)?/?(/[^[:space:]&#?]+)*(\\?[^[:space:]#]+)?(#[^[:space:]<>\"])?", '<a href="\\0" target="_blank">\\0</a>', $ment);
}

// {{{ ReplyPrint
class ReplyPrint extends ReplyBasic
{
    var $result;

    var $autolink;
    var $htmltag;
    var $show_ip;

    var $skin_path;
    var $page_num = NULL;

    function ReplyPrint($no)
    {
        $DBConn = new DBConnection;

        $this->result =& $DBConn->query("SELECT * FROM hboard_db_comment WHERE article={$no} AND deleted<>'t'");

        $Config =& $GLOBALS['Config'];

        $this->autolink =& $Config->autolink;
        $this->htmltag  =& $Config->htmltag;
        $this->show_ip  =& $Config->checkAdmin;

        $this->skin_path = 'skin/' . $Config->skin;
    }

    function setPageNum(&$page)
    {
        $this->page_num =& $page;
    }

    function printOut()
    {
        if (!$this->result) return;

        do {
            $this->attach($this->result);

            $this->name     = htmlspecialchars($this->name);
            $this->email    = htmlspecialchars($this->email);
            $this->homepage = htmlspecialchars($this->homepage);

            if (!$this->htmltag) $this->content = htmlspecialchars($this->content);
            if ($this->autolink) $this->content =& AutoLink($this->content);
            $this->content= nl2br($this->content);

            echo "<div class=\"hbComment\"><hr />No. {$this->rno} [by ";

            echo empty($this->email) ? $this->name : "<a href=\"mailto:{$this->email}.NOSPAM\" title=\"클릭하시면 작성자에게 메일을 전송합니다.\">{$this->name}</a>";
            if (!empty($this->homepage)) echo " <a href=\"{$this->reply->homepage}\" target=\"_blank\" title=\"홈페이지\"><img src=\"{$skin_path}/home.gif\" alt=\"홈페이지\"></a>";
            if ($this->show_ip) echo " (from {$this->ipaddress})";

            echo <<<REPLYHTML
] {$this->date}
 <a href="del_comment.php?article={$this->no}&amp;num={$this->rno}&amp;page={$this->page_num}" title="의견글 삭제"><img src="{$this->skin_path}/del_cmt.gif" alt="의견글 삭제" class="middle" /></a>
 <table cellpadding="1" cellspacing="1">
  <tr><td align="center" valign="top">
REPLYHTML;

            if ($this->icon == 'none.jpg' || !file_exists('db/ico/' . $this->icon)) {
                echo "<img src=\"{$this->skin_path}/none.jpg\" alt=\"No Icon\" />";
            } else { 
                echo '<img src="db/ico/' . rawurlencode($this->icon) . "\" alt=\"{$this->icon}\" />";
            }

            echo "</td><td valign=\"top\" class=\"fgMent\">{$this->content}</td></tr>\n</table></div>";
        } while ($this->result->goNext());
    }
}
// }}}

// {{{ ArticlePrint
class ArticlePrint extends ArticleBasic
{
    var $htmltag;
    var $autolink;
    var $maxwidth;
    var $show_ip;
    var $skin_path;

    var $show_btn = TRUE;
    var $page_num = NULL;

    function ArticlePrint($no = NULL)
    {
        $this->ArticleBasic($no);

        $Config =& $GLOBALS['Config'];

        $this->autolink =& $Config->autolink;
        $this->htmltag  =& $Config->htmltag;
        $this->maxwidth =& $Config->imgwidth_max;
        $this->show_ip  =& $Config->checkAdmin;

        $this->skin_path = 'skin/' . $Config->skin;
    }

    function hideButtons()
    {
        $this->show_btn = FALSE;
    }

    function setPageNum($page)
    {
        $this->page_num =& $page;
    }

    function outputPrepare()
    {
        $this->name     = htmlspecialchars($this->name);
        $this->email    = htmlspecialchars($this->email);
        $this->homepage = htmlspecialchars($this->homepage);
        $this->subject  = htmlspecialchars($this->subject);
        $this->useragent = htmlspecialchars($this->useragent);

        if (!$this->htmltag) $this->content = htmlspecialchars($this->content);
    }

    function outputReal()
    {
        // {{{ 머리
        if ($this->deleted) $this->subject = '삭제된 게시물입니다.';
        elseif (empty($this->subject)) $this->subject = '(제목 없음)';

        $title_line = "No. {$this->no} - <b>{$this->subject}</b> <span class=\"fgSpc1\">[by ";
        $title_line .= empty($this->email) ? $this->name : "<a href=\"mailto:{$this->email}.NOSPAM\" class=\"fgSpc1\">{$this->name}</a>";
        if (!empty($this->homepage)) $title_line .= " <a href=\"{$this->homepage}\" target=\"_blank\" title=\"홈페이지\"><img src=\"{$this->skin_path}/home.gif\" alt=\"홈페이지\" /></a>";
        $title_line .= " - {$this->date}]</span>";

        echo <<<AHEADHTML
<form action="post_comment.php" method="post" onsubmit="return checkform_comment(this);">
 <div id="a{$this->no}" class="hbArticle">
  <div class="bgTitle hbTitle">{$title_line}</div>
  <div class="bgImage hbBody">
AHEADHTML;
        // }}}

        // {{{ 몸통
        if ($this->deleted) {
            echo <<<ADELETEDHTML
   <p class="center"><img src="{$this->skin_path}/deleted.jpg" alt="deleted" /></p>
   <p class="center"><strong>이 게시물은 작성자 혹은 관리자에 의해 삭제되었습니다.</strong></p>
ADELETEDHTML;
        } else {
            $this->image->setMaxWidth($this->maxwidth);
            $this->image->printOut();

            if ($this->autolink) $this->content =& AutoLink($this->content);
            $content = nl2br($this->content);
            $size_k = sprintf('%.2f', $this->image->size / 1024);

            echo <<<ABODYHTML
  <div class="bgText hbContent"><p class="fgMent">{$content}</p></div>
  <div class="fontXSmall">
   * <b>User Agent:</b> {$this->useragent}<br />
   * <b>File Size:</b> {$this->image->size} Byte(s) ({$size_k} KB) <b>[<a href="downadd.php?file={$this->image->name}">DOWNLOAD</a>]</b>
ABODYHTML;

            if ($this->show_ip) echo "<br />\n* <b>IP Address:</b> {$this->ipaddress}";
            echo '</div>';
        }
        // }}}

        // 덧글
        if ($this->replies) {
            $Reply = new ReplyPrint($this->no);
            $Reply->setPageNum($this->page_num);

            $Reply->printOut();
        }

        // {{{ 버튼
        if($this->show_btn && !$this->deleted) {
            echo <<<BTNHTML
<div class="hbButton">
 <a href="modify.php?article_no={$this->no}&amp;page={$this->page_num}" title="글 수정"><img src="{$this->skin_path}/modify.gif" alt="글 수정" /></a>
 <a href="del_article.php?article={$this->no}&amp;page={$this->page_num}" title="글 삭제"><img src="{$this->skin_path}/delete.gif" alt="글 삭제" /></a>
 <a href="comment.php?article={$this->no}&amp;page={$this->page_num}" title="의견 달기" onclick="return show_comment_form({$this->no});" ondblclick="window.location.href='comment.php?article={$this->no}&amp;page={$this->page_num}';"><img src="{$this->skin_path}/reply.gif" alt="의견 달기" /></a>
</div>
<div id="comment_form{$this->no}" class="hbCForm"></div>
BTNHTML;
        }
        // }}}

        echo '</div></div></form>';
    }

    function printOut()
    {
        $this->outputPrepare();
        $this->outputReal();
    }
}
// }}}

?>
