<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: article.write.php,v 1.8 2004/05/12 07:39:27 lseeker Exp $
 */

define('FILETYPE_CHECK',   1 << 0);
define('FILETYPE_GIF',     1 << 1);
define('FILETYPE_JPG',     1 << 2);
define('FILETYPE_PNG',     1 << 3);
define('FILETYPE_BMP',     1 << 6);
define('FILETYPE_TIFF',    1 << 7);
define('FILETYPE_UNKNOWN', 1 << 9);

function &remove_space(&$str) {
    return trim(str_replace('　', ' ', $str));
}

// {{{ ImageUpload
class ImageUpload extends ImageBasic
{
    function ImageUpload()
    {
        if ($_FILES['picture']['error']) trigger_error('<b>PHP 업로드 처리 중에 오류가 발생했습니다.</b><br />PHP Upload Error: Code ' . $_FILES['picture']['error'], E_USER_WARNING);

        $this->ImageBasic($_FILES['picture']['tmp_name']);
    }

    function checkSize(&$maxsize)
    {
        if ($_FILES['picture']['size'] > $maxsize) trigger_error(sprintf('<b>파일의 크기가 너무 큽니다!</b><br>※ 파일의 크기는 최대 %dKB로 제한됩니다.', $maxsize / 1024), E_USER_WARNING);
    }

    function checkType(&$allowed)
    {
        $error = FALSE;
        switch ($this->type) {
            case 1:
                if (!($allowed & FILETYPE_GIF)) $error = 'GIF';
                break;
            case 2:
                if (!($allowed & FILETYPE_JPG)) $error = 'JPG';
                break;
            case 3:
                if (!($allowed & FILETYPE_PNG)) $error = 'PNG';
                break;
            case 6:
                if (!($allowed & FILETYPE_BMP)) $error = 'BMP';
                break;
            case 7:
            case 8:
                if (!($allowed & FILETYPE_TIFF)) $error = 'TIFF';
                break;
            default:
                if (!($allowed & FILETYPE_UNKNOWN)) $error = 'unknown';
        }

        if ($error) trigger_error($error . ' 형식의 파일은 업로드 할 수 없습니다.', E_USER_WARNING);
    }

    function checkMD5() {
        $DBConn = new DBConnection;

        $Result = $DBConn->query("SELECT * FROM hboard_db_article WHERE md5='{$this->md5}' AND deleted<>'t' LIMIT 1");

        if ($Result) {
            // XXX Must changed
            require 'lib/article.print.php';

            $Article = new ArticlePrint;
            $Article->attach($Result);
            $Article->hideButtons();
            delete($Result);

            $Layout = new Layout;
            $Layout->hideInclude();
            $Message = new MessageBox;
            $Message->setTypeBack();
            $Message->registerMessage("<b>{$Article->no}번 글에서 같은 파일이 발견되었습니다.</b>");

            $Layout->printHeader();
            $Message->printOut();
            $Article->printOut();
            echo '<p class="center">[<a href="javascript: history.back(1);">돌아가기</a>]</p>';
            $Layout->printFooter();

            unlink($this->file);
            exit;
        }
    }

    function upload($no) {
        $filename = date('Y_m_d') . '_' . str_pad($no, 6, '0', STR_PAD_LEFT);

        switch ($this->type) {
            case 1:
                $filename .= '.gif';
                break;
            case 2:
                $filename .= '.jpg';
                break;
            case 3:
                $filename .= '.png';
                break;
            case 6:
                $filename .= '.bmp';
                break;
            case 7:
            case 8:
                $filename .= '.tiff';
                break;
            default:
                $filename .= '.unknown';
        }

        umask(0111);
        move_uploaded_file($this->file, 'db/img/' . $filename);

        $DBConn = new DBConnection;

        $DBConn->exec("UPDATE hboard_db_article SET cfile='{$filename}', md5='{$this->md5}' WHERE idx={$no}");
        $DBConn->exec("UPDATE hboard_db_admin SET article_max=article_max+{$this->size}");
    }
}
// }}}

// {{{ ArticleWrite
class ArticleWrite extends ArticleBasic
{
    var $new_password;
    var $new_image;

    function ArticleWrite($no = NULL)
    {
        $this->new_image = empty($_FILES['picture']['name']) ? NULL : new ImageUpload($_FILES['picture']['tmp_name']);

        $this->new_password = empty($_POST['passwd']) ? NULL : $_POST['passwd'];

        if ($no === NULL) {
            if ($this->new_image === NULL) trigger_error('업로드할 파일을 지정해주세요.', E_USER_WARNING);
            if ($this->new_password === NULL) trigger_error('패스워드를 지정해주세요.', E_USER_WARNING);
            $this->date = date('Y/m/d H:i:s');
        } else {
            $this->ArticleBasic($no);
            $this->checkDeleted();
            $this->date .= '*';
        }

        $this->name     =& remove_space($_POST['name']);
        $this->email    =& remove_space($_POST['email']);
        $this->homepage =& remove_space($_POST['homepage']);
        $this->subject  =& quote_string(remove_space($_POST['title']));
        $this->content  =& quote_string($_POST['ne']);

        if ($this->name == '' || $this->content == '') trigger_error('이름과 내용은 꼭 입력해야 합니다.', E_USER_WARNING);

        if (!strcmp($this->homepage, 'http://')) $this->homepage = '';

        $this->useragent =& quote_string($_SERVER['HTTP_USER_AGENT']);
        $this->ipaddress =& $_SERVER['REMOTE_ADDR'];
    }

    function checkPassword()
    {
        parent::checkPassword($this->new_password);
    }

    function checkFileType(&$type)
    {
        if ($type & FILETYPE_CHECK && $this->new_image) $this->new_image->checkType($type);
    }

    function checkFileSize(&$size)
    {
        if ($size && $this->new_image) $this->new_image->checkSize($size);
    }

    function checkFileMD5(&$flag)
    {
        if ($flag && $this->new_image) $this->new_image->checkMD5();
    }

    function writeCookie()
    {
        $cookie_time = time() + 2592000;
        setcookie('etchibbs_name', get_magic_quotes_gpc() ? stripslashes($this->name) : $this->name, $cookie_time);
        setcookie('etchibbs_mail', get_magic_quotes_gpc() ? stripslashes($this->email) : $this->email, $cookie_time);
        setcookie('etchibbs_home', get_magic_quotes_gpc() ? stripslashes($this->homepage) : $this->homepage, $cookie_time);
    }

    function writeDB() {
        $this->name     =& quote_string($this->name);
        $this->email    =& quote_string($this->email);
        $this->homepage =& quote_string($this->homepage);

        ignore_user_abort(TRUE);

        $DBConn = new DBConnection;
        $DBConn->begin();

        if ($this->no) {
            // On UPDATE
            $DBConn->exec("UPDATE hboard_db_article SET name='{$this->name}', email='{$this->email}',home='{$this->homepage}', date='{$this->date}', subject='{$this->subject}', ment='{$this->content}' WHERE idx='{$this->no}'");
            if ($this->new_image) $this->image->remove();
        } else {
            // On New Article
            mt_srand(microtime() * 1e6);
            $password =& quote_string(crypt($_POST['passwd'], chr(mt_rand(0x21, 0x7E)) . chr(mt_rand(0x21, 0x7E))));

            $DBConn->exec("INSERT INTO hboard_db_article (name, email, home, ipaddr, passwd, date, subject, ment, agent) VALUES ('{$this->name}', '{$this->email}', '{$this->homepage}', '{$this->ipaddress}', '{$password}', '{$this->date}', '{$this->subject}', '{$this->content}', '{$this->useragent}')");
            $this->no = $DBConn->getLastArticleNum();
        }

        if ($this->new_image) $this->new_image->upload($this->no);

        $DBConn->commit();
    }
}
// }}}

?>
