<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: common.php,v 1.38 2004/11/17 13:12:58 lseeker Exp $
 */

define('__VERSION__', 'Spiral-dev');

// FOR RELEASE
// error_reporting(E_ERROR | E_CORE_ERROR | E_COMPILE_ERROR | E_USER_ERROR | E_USER_NOTICE);

// 헤더 출력 : 에러 메시지를 위해 여기가 적합.
if (!defined('NO_HTML_HEADER')) header('Content-Type: text/html; charset=UTF-8');
if (!defined('NO_NOCACHE_HEADER')) header('Cache-Control: no-cache, must-revalidate');
set_magic_quotes_runtime(0);

// DBMS 파일 읽기
$_DBConnectionInfo = file('db/dbconn.php') or trigger_error('게시판이 설치되어 있지 않습니다. 설치 메뉴얼을 참조하신 후, 설치해 주시기 바랍니다.', E_USER_ERROR);

require 'lib/db.' . trim($_DBConnectionInfo[1]) . '.php';

// {{{ ConfingData class
class ConfigData
{
    var $checkAdmin;
    var $skin;
    var $language = 'ko';
    var $password;

    var $html_title;
    var $html_head;
    var $file_head;
    var $file_foot;
    var $bg_image;

    var $app;
    var $deleted_count;
    var $dbsize;
    var $imgwidth_max;
    var $filesize_max;
    var $allow_filetype;

    var $htmltag;
    var $autolink;
    var $md5check;

    function ConfigData()
    {
        // {{{ Constructor
        $DBConn = new DBConnection();

        $Result =& $DBConn->query('SELECT * FROM hboard_db_admin');

        if (!$Result) trigger_error('게시판 설정을 읽을 수 없습니다.', E_USER_ERROR);

        $this->password =& $Result->getValue('passwd');
        $this->checkAdmin = isset($_COOKIE['hboard_admin_login']) && md5($this->password) == $_COOKIE['hboard_admin_login'] ? TRUE : FALSE; 

        $this->skin =& $Result->getValue('skin');

        if (!file_exists("skin/{$this->skin}/style.php")) {
            trigger_error('지정한 스킨을 찾을 수 없습니다. 기본 스킨을 읽습니다.', E_USER_NOTICE);
            if (!file_exists('skin/frog_yellow/style.php')) trigger_error('기본 스킨을 읽을 수 없습니다.', E_USER_ERROR);
            $this->skin = 'frog_yellow';
        }

        $this->language =& $Result->getValue('lang');
        /* TODO language selector
        if (!empty($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
            $accept_langs = explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
            foreach ($accept_langs as $lang) {
                $code = explode(';q=', $lang);
                if (empty($code[1])) $code[1] = '1';
                $langs[$code[1]] = $code[0];
            }
            ksort($langs);

            while ( ($lang = array_pop($langs)) !== NULL) {
                if (file_exists("lib/message.{$lang}.php")) {
                    $this->language = $lang;
                    break;
                }
            }
        }
        */

        $this->html_title =& $Result->getValue('titlebar');
        $this->html_head  =& $Result->getValue('title_text');
        $this->file_head  =& $Result->getValue('include_top');
        $this->file_foot  =& $Result->getValue('include_bottom');
        $this->bg_image   =& $Result->getValue('bgimage');

        $this->app = (int) $Result->getValue('app');
        $this->deleted_count = (int) ($this->app / 100);
        $this->app -= $this->deleted_count * 100;

        $this->dbsize = (int) $Result->getValue('article_max');

        $this->allow_filetype = (int) $Result->getValue('width_max');
        $this->imgwidth_max = $this->allow_filetype >> 10;
        $this->filesize_max = (int) $Result->getValue('fileup_max');

        $this->htmltag  = $Result->getValue('html_tag') == 't' ? TRUE : FALSE;
        $this->autolink = $Result->getValue('autolink') == 't' ? TRUE : FALSE;
        $this->md5check = $Result->getValue('backdrum') == 't' ? TRUE : FALSE;

        delete($Result);
        // }}}
    }

    function checkAdmin()
    {
        if (!$this->checkAdmin) trigger_error('관리자 전용 페이지입니다.', E_USER_ERROR);
    }
}
// }}}

$Config = new ConfigData;
// XXX 하위 호환용
define('__SKIN__', $Config->skin);

// {{{ class Container
class Container // implements show
{
    var $entries;

    function Container()
    {
        $this->entries = array();
    }

    function addEntry(/* OutputImplement */ &$entry)
    {
        $this->entries[] =& $entry;
    }

    function show()
    {
        foreach ($this->entries as $entry) $entry->show();
    }
}
// }}}
// {{{ class Text
class Text // implements show
{
    var $text;

    function Text($text)
    {
        $this->text = $text;
    }

    function show()
    {
        echo $this->text;
    }
}
// }}}

// {{{ Layout class
class Layout extends Container
{
    var $html_title;
    var $html_head;
    var $file_head;
    var $file_foot;
    var $bg_image;
    var $skin;

    var $show_head = TRUE;

    function Layout()
    {
        $this->Container();

        $ConfigData =& $GLOBALS['Config'];

        $this->html_title =& $ConfigData->html_title;
        $this->html_head  =& $ConfigData->html_head;
        $this->file_head  =& $ConfigData->file_head;
        $this->file_foot  =& $ConfigData->file_foot;
        $this->bg_image   =& $ConfigData->bg_image;
        $this->skin       =& $ConfigData->skin;
    }

    function hideInclude()
    {
        $this->file_head = NULL;
        $this->file_foot = NULL;
    }

    function hideHeadText()
    {
        $this->show_head = FALSE;
    }

    function printHeader()
    {
        // {{{ printHeader()
        include 'skin/' . $this->skin . '/style.php';

        $title = empty($this->html_title) ? 'EtchiBBS ' . __VERSION__ . ' :: ' . strtoupper(basename($_SERVER['PHP_SELF'], '.php')) : htmlspecialchars($this->html_title);

        $bg_css = empty($this->bg_image) ? '' : "background-image: url('{$this->bg_image}'); ";

        if (!empty($this->file_head)) include $this->file_head;

        echo <<<HEADHTML1
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
 <title>{$title}</title>
 <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
 <link href="etchibbs.css" rel="stylesheet" type="text/css">
 <style type="text/css">
body { {$bg_css}background-color: {$skin['body_bgcolor']}; color: {$skin['text_color']} }
a:link    { color: {$skin['link_color']} }
a:visited { color: {$skin['link_color']} }
a:active  { color: {$skin['link_color']} }
hr { background-color: {$skin['hr_color']}; color: {$skin['hr_color']} }

.bgTitle { background-image: url('skin/{$this->skin}/title_bg.gif') }
.bgImage { background-color: {$skin['image_table_bgcolor']} }
.bgText  { background-color: {$skin['text_table_bgcolor']} }
.fgMent  { color: {$skin['ment_fontcolor']} }
.fgSpc1  { color: {$skin['sfont1_color']} }
.fgSpc2  { color: {$skin['sfont2_color']} }
 </style>
HEADHTML1;
        PrintCSS();
        echo <<<HEADHTML2
 <script type="text/javascript">
<!--
var skin_path = 'skin/{$this->skin}/';
//-->
 </script>
 <script type="text/javascript" src="etchibbs.js"></script>
</head>
<body>
HEADHTML2;
        if ($this->show_head) echo $this->html_head;
        // }}}
    }

    function printFooter()
    {
        $design_data = file('skin/' . $this->skin . '/designed_by.txt');
        $designer['name'] = trim($design_data[0]);
        $designer['url']  = trim($design_data[1]);
        $version = __VERSION__;

        echo <<<BBSINFO
 <address id="hbCopyright" class="bgImage">
  EtchiBBS {$version} <a href="LICENSE">&copy;</a> 2004 <a href="http://etchibbs.kldp.net">EtchiBoard Project</a><br />
  Skin designed by <a href="{$designer['url']}">{$designer['name']}</a>
 </address>
BBSINFO;

        if (!empty($this->file_foot)) include $this->file_foot;

        echo "</body>\n</html>\n";
    }

    function show()
    {
        $this->printHeader();
        parent::show();
        $this->printFooter();
    }
}
// }}}

// {{{ MessageBox class
class MessageBox extends Container
{
    var $title   = 'MESSAGE';
    var $message = '';
    var $type    = NULL;
    var $list_page;
    var $list_no;

    function MessageBox($title = NULL, $message = NULL)
    {
        $this->Container();

        $this->title   = $title;
        $this->message = $message;
    }

    function show()
    {
        echo "<div id=\"hbMBox\"><div class=\"bgTitle fgSpc2 hbTitle\">{$this->title}</div><div class=\"bgImage hbMessage\"><p class=\"center\">{$this->message}</p>";
        parent::show();
        echo '</div></div>';
    }

    function registerTitle($title) {
        $this->title =& $title;
    }

    function registerMessage($message) {
        $this->message =& $message;
    }

    function setTypeList($page, $no) {
        $this->type      = 2;
        $this->list_page = (int) $page;
        $this->list_no   = (int) $no;
    }

    function setTypeBack() {
        $this->type = 1;
    }

    function printOut() {
        echo <<<MESSAGEBOX
<div id="hbMBox">
 <div class="bgTitle fgSpc2 hbTitle">{$this->title}</div>
 <div class="bgImage hbMessage">
  <p class="center">{$this->message}</p>
MESSAGEBOX;

        switch($this->type) {
            case 1:
                echo '<p class="center">[<a href="javascript: history.back(1);">돌아가기</a>]</p>';
                break;
            case 2:
                echo "<p class=\"center\"><span class=\"fgSpc1\">잠시 후에 <a href=\"list.php?page={$this->list_page}#a{$this->list_no}\"><b class=\"fgSpc1\">게시물 목록</b></a>으로 이동합니다.</span></p>\n<script type=\"text/javascript\">\n<!--\nwindow.setTimeout('movetolist({$this->list_page}, {$this->list_no})', 1500);\n//-->\n</script>";
                break;
        }

        echo '</div></div>';
    }
}
// }}}
// {{{ class ErrorBox
class ErrorBox extends MessageBox
{
    function ErrorBox($message)
    {
        $this->MessageBox('ERROR', $message);
        $this->addEntry(new Text('<p class="center">[<a href="javascript: history.back(1);">돌아가기</a>]</p>'));
    }
}
// }}}

// {{{ error_handler
function error_handler($no, $msg, $file, $line)
{
    // TODO error message handler i18n
    //    require_once 'lib/errorhandler.php';
    $ErrorBox = new ErrorBox($msg);

    switch ($no) {
        case E_USER_ERROR:
            $ErrorBox->show();
            exit;
        case E_USER_WARNING:
            $Layout = new Layout;
            $Layout->hideInclude();
            $Layout->addEntry($ErrorBox);
            $Layout->show();
            exit;
        case E_USER_NOTICE:
            $ErrorBox->show();
    }
}
// }}}

set_error_handler('error_handler');

// {{{ function delete - object destructor
function delete(&$obj)
{
    $class_name = get_class($obj);

    if ($class_name !== FALSE) {
        $destructor = '_' . $class_name;
        if (method_exists($obj, $destructor)) $obj->$destructor();
    }

    unset($obj);
}
// }}}

// {{{ SkinImage
define('SKIN_IMAGE_SEARCH', 1);
define('SKIN_IMAGE_INFO', 2);
define('SKIN_IMAGE_CONFIG', 3);
define('SKIN_IMAGE_ICON_MANAGER', 4);
define('SKIN_IMAGE_LOGIN', 5);
define('SKIN_IMAGE_LOGOUT', 6);

class SkinImage
{
    var $file;
    var $alt;
    var $width;
    var $height;
    var $class;

    function SkinImage($imgid, $class = NULL)
    {
        $this->class = $class;

        // TODO file move to skin conf, alt move to message
        switch ($imgid) {
            case SKIN_IMAGE_SEARCH:
                $this->file = 'search.jpg';
                $this->alt  = '검색';
                break;
            case SKIN_IMAGE_INFO:
                $this->file = 'info.jpg';
                $this->alt  = '정보';
                break;
            case SKIN_IMAGE_CONFIG:
                $this->file = 'config.jpg';
                $this->alt  = '게시판 환경 설정';
                break;
            case SKIN_IMAGE_ICON_MANAGER:
                $this->file = 'addicon.jpg';
                $this->alt  = '아이콘 관리자';
                break;
            case SKIN_IMAGE_LOGIN:
                $this->file = 'login.jpg';
                $this->alt  = '관리자 로그인';
                break;
            case SKIN_IMAGE_LOGOUT:
                $this->file = 'logout.jpg';
                $this->alt  = '관리자 로그아웃';
                break;
        }
    }

    function show()
    {
        echo '<img src="skin/', __SKIN__, "/{$this->file}\" alt=\"{$this->alt}\" ";
        if ($this->class) echo "class=\"{$this->class}\" ";
        echo '/>';
    }
}

class SkinImageLink extends SkinImage
{
    var $href;

    function SkinImageLink($imgid, $href, $class = NULL)
    {
        $this->SkinImage($imgid, $class);

        $this->href = htmlspecialchars($href);
    }

    function show()
    {
        echo "<a href=\"{$this->href}\" title=\"{$this->alt}\">";
        parent::show();
        echo '</a> ';
    }
}
// }}}

?>
