<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: list.class.php,v 1.15 2004/05/12 06:56:59 lseeker Exp $
 */

require_once 'lib/form.php';

/* {{{ ToolBox class */
class ToolBox extends Container
{
    function ToolBox($content, $is_admin = FALSE) {
        $nowpage = $this->nowpage = rawurlencode($_SERVER['REQUEST_URI']);

        $this->addEntry(new Text('<div id="hbTBox"><div class="bgImage hbMain">'));
        $this->addEntry(new SkinImage(SKIN_IMAGE_INFO, 'left'));
        $this->addEntry(new Text('<div class="Tools">'));
        $this->addEntry(new SkinImageLink(SKIN_IMAGE_SEARCH, '#search'));

        if ($is_admin) {
            $this->addEntry(new SkinImageLink(SKIN_IMAGE_CONFIG, "config.php?from={$nowpage}"));
            $this->addEntry(new SkinImageLink(SKIN_IMAGE_ICON_MANAGER, 'javascript:Openwindow(\'hb_iconman\', \'iconman.php\', 60, 60, 610, 400, 0, 0, 0, 1, 1)'));
            $this->addEntry(new SkinImageLink(SKIN_IMAGE_LOGOUT, "admin.php?from={$nowpage}"));

        } else $this->addEntry(new SkinImageLink(SKIN_IMAGE_LOGIN, "admin.php?from={$nowpage}"));

        $this->addEntry(new Text("</div>{$content}</div></div>"));
    }
}
/* }}} */

/* {{{ SearchForm class */
class SearchForm extends Form
{
    function SearchForm($type = NULL, $word = NULL)
    {
        $this->Form('search.php');
        $this->onSubmit('checkform_search(this)');

        // TODO drop table
        $this->addEntry(new Text('<div id="search"><table align="center" cellpadding="2" cellspacing="2" class="bgImage"><tr><td align="right">'));

        $WordInput = new FormEntryText('word', $word, 15, 50);
        $this->addEntry($WordInput->getLabel(new SkinImage(SKIN_IMAGE_SEARCH)));
        $this->addEntry(new Text('</td><td>'));

        $this->addEntry(new FormEntrySelect('type', $type, array('name' => '작성자', 'subject' => '글 제목', 'content' => '글 내용', 'image' => '파일 이름')));

        $this->addEntry($WordInput);
        $this->addEntry(new FormEntrySubmit(NULL, '검색'));

        $this->addEntry(new Text('</td></tr></table></div>'));
    }
}
/* }}} */

/* {{{ Paging class */
class Paging
{
    var $total_num = 0;
    var $per_page  = 5;
    var $link_address = NULL;

    var $now_page   = 1;
    var $total_page = 1;
    var $show_count = 9;
    var $show_stat  = TRUE;

    var $btn_first = '|';
    var $btn_last  = '|';
    var $btn_prev  = '◁';
    var $btn_next  = '▷';

    function Paging($at, $pp)
    {
        $this->total_num = $at;
        $this->per_page  = $pp;

        $this->total_page = (int) (($this->total_num + $this->per_page - 1) / $this->per_page);
        if ($this->total_page <= 0) $this->total_page = 1;

        $this->now_page = empty($_GET['page']) ? 1 : (int) $_GET['page'];

        if ($this->now_page < 1 || $this->now_page > $this->total_page) trigger_error('페이지 범위를 초과했습니다.', E_USER_WARNING);
    }

    function registerAddress($address) {
        $this->link_address =& $address;
    }

    function hideStats() {
        $this->show_stat = FALSE;
    }

    function registerButton($first, $prev, $next, $last) {
        $this->btn_first =& $first;
        $this->btn_prev  =& $prev;
        $this->btn_next  =& $next;
        $this->btn_last  =& $last;
    }

    function registerCount($n) {
        $this->show_count = (int) $n;
    }

    function printOut() {
        echo '<div id="Paging">';

        if ($this->show_stat) echo "현재 <span class=\"StatNow\">{$this->now_page}</span> 페이지 <span class=\"StatDiv\">/</span> 전체 <span class=\"StatTotal\">{$this->total_page}</span> 페이지<br />";

        echo $this->now_page == 1 ? "<span class=\"BtnNonActive\">{$this->btn_first}</span> <span class=\"BtnNonActive\">{$this->btn_prev}</span> " : "<a href=\"{$this->link_address}1\" title=\"처음 페이지\">{$this->btn_first}</a> <a href=\"{$this->link_address}" . ($this->now_page - 1) . "\" title=\"이전 페이지\">{$this->btn_prev}</a> ";

        if ($this->total_page >= $this->show_count) {
            $range = (int) ($this->show_count / 2); 
            if ($this->now_page <= $range) {
                for ($i = 1; $i <= $this->show_count; $i++) echo $this->now_page == $i ? "<span class=\"PageNow\">[{$i}]</span> " : "<a href=\"{$this->link_address}{$i}\">[{$i}]</a> ";
            } elseif ($this->now_page >= $this->total_page - $range) {
                for ($i = $this->total_page - $this->show_count + 1; $i <= $this->total_page; $i++) echo $this->now_page == $i ? "<span class=\"PageNow\">[{$i}]</span> " : "<a href=\"{$this->link_address}{$i}\">[{$i}]</a> ";
            } else {
                $end = $this->now_page + $range + 1;
                for ($i = $this->now_page - $this->show_count + $range + 1; $i < $end; $i++) echo $this->now_page == $i ? "<span class=\"PageNow\">[{$i}]</span> " : "<a href=\"{$this->link_address}{$i}\">[{$i}]</a> ";
            }
        } else {
            for ($i = 1; $i <= $this->total_page; $i++) echo $this->now_page == $i ? "<span class=\"PageNow\">[{$i}]</span> " : "<a href=\"{$this->link_address}{$i}\">[{$i}]</a> ";
        }

        echo $this->now_page == $this->total_page ? "<span class=\"BtnNonActive\">{$this->btn_next}</span> <span class=\"BtnNonActive\">{$this->btn_last}</span>" : "<a href=\"{$this->link_address}" . ($this->now_page + 1) . "\" title=\"다음 페이지\">{$this->btn_next}</a> <a href=\"{$this->link_address}{$this->total_page}\" title=\"마지막 페이지\">{$this->btn_last}</a>";

        echo '</div>';
    }
}
/* }}} */

?>
