<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: list.php,v 1.107 2004/05/11 18:57:45 lseeker Exp $
 */

require 'lib/common.php';
include 'lib/writeform.php';
require 'lib/article.basic.php';
require 'lib/article.print.php';
include 'lib/list.class.php';

// 전체 게시물 수 구하기
$DBConn = new DBConnection;
$fileidx =& $DBConn->getArticleCount();

// 페이징 계산
$Paging = new Paging($fileidx, $Config->app);
$Paging->registerAddress('list.php?page=');

// 쓰기 폼 설정
$WriteForm = new WriteForm('article');
$WriteForm->readCookie();
if ($Config->filesize_max) {
    $WriteForm->registerFileDesc('(' . ($Config->filesize_max < 1024000 ? sprintf('%dKB', $Config->filesize_max / 1024) : sprintf('%.2fMB', $Config->filesize_max / 1049576)) . ' <span class="fgMaxSize">MAX</span>)');
} else {
    $WriteForm->registerFileDesc('<span class="fgMaxSize">(Unlimited)</span>');
}

// 도구 상자 설정
$db_size = $Config->dbsize <= 1048576 ? sprintf('%.2f KB', $Config->dbsize / 1024) : sprintf('%.2f MB', $Config->dbsize / 1048576);
$ToolBox = new ToolBox(
    '총 ' . ($fileidx - $Config->deleted_count) . "개의 게시물이 등록되어 있습니다. (삭제된 게시물 {$Config->deleted_count}개)<br /> 현재 {$Paging->now_page} 페이지 / 전체 {$Paging->total_page} 페이지 (페이지당 {$Config->app}개씩 출력, 이미지 DB: {$db_size})",
    $Config->checkAdmin);

// 리스트 설정
// {{{ ArticleList class
class ArticleList extends ArticlePrint
{
    var $result;

    function ArticleList(&$Result)
    {
        $this->result =& $Result;
        $this->ArticlePrint();
    }

    function printOut()
    {
        if (!$this->result) {
            $Notice = new MessageBox;
            $Notice->registerTitle('안내');
            $Notice->registerMessage('<span class="fontXLarge">데이터가 없습니다!</span><br />상단의 입력폼에서 게시물을 작성하여 주십시오.');
            $Notice->printOut();
        } else {
            do {
                $this->attach($this->result);
                parent::printOut();
            } while ($this->result->goNext());
        }
    }
}
// }}}

$footart = $fileidx - $Config->app * $Paging->now_page;
$headart = $footart + $Config->app;

$ArticleList = new ArticleList($DBConn->query("SELECT idx, name, email, home, ipaddr, date, cfile, subject, ment, deleted, reply, agent FROM hboard_db_article WHERE idx>{$footart} AND idx<={$headart} ORDER BY idx DESC"));
$ArticleList->setPageNum($Paging->now_page);

// 검색폼 준비
$SearchForm = new SearchForm;

// 출력
$Layout = new Layout;

$Layout->printHeader();
// {{{ JS
?>
<script type="text/javascript">
<!--
var page = <?php echo $Paging->now_page; ?>;
var cookie_name = "<?php echo $WriteForm->name; ?>";
var cookie_mail = "<?php echo $WriteForm->email; ?>";
var cookie_home = "<?php echo $WriteForm->homepage; ?>";
var icon_list = new Array(<?php
$IconDir = dir('db/ico/');
$icon_list = array();
while ( ($filename = $IconDir->read()) !== FALSE) { 
    if ($filename != '.' && $filename != '..' && $filename != 'none.jpg' && $filename != 'index.html') $icon_list[] = '"' . htmlspecialchars($filename) . '"';
}
$IconDir->close();
echo implode(',', $icon_list);
?>);
var now_icon = "<?php echo htmlspecialchars($WriteForm->icon); ?>";
var icon_preview = '<?php echo strcmp($WriteForm->icon, '') && file_exists('db/ico/'. $WriteForm->icon) ? 'db/ico/' . rawurlencode($WriteForm->icon) : "skin/{$Config->skin}/none.jpg"; ?>';
-->
</script>
<script type="text/javascript" src="commentform.js"></script>
<?php
// }}}
$WriteForm->show();
$ToolBox->show();
$ArticleList->printOut();
$Paging->printOut();
$SearchForm->show();
$Layout->printFooter();

?>
