<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: post_comment.php,v 1.48 2004/05/15 18:10:33 lseeker Exp $
 */

require 'lib/common.php';
require 'lib/reply.php';

function &remove_space(&$str) {
    return trim(str_replace('　', ' ', $str));
}

// 공백 처리: ^^+
$name     =& remove_space($_POST['name']);
$homepage =& remove_space($_POST['homepage']);
$email    =& remove_space($_POST['email']);

/* {{{ */
if (get_magic_quotes_gpc()) {
    $cname     = stripslashes($name);
    $cemail    = stripslashes($email);
    $chomepage = stripslashes($homepage);
    $cicon     = stripslashes($_POST['icon']);
} else {
    $cname     =& $name;
    $cemail    =& $email;
    $chomepage =& $homepage;
    $cicon     =& $_POST['icon'];
}
/* }}} */

if($cname == '' || empty($cicon) || empty($_POST['ne']) || empty($_POST['passwd'])) trigger_error('<b>데이터가 모두 전송되지 않았습니다.</b><br />필요한 폼에 데이터를 모두 채워주세요.', E_USER_ERROR);

/* 전부 정상이라면.. */
$article_no = (int) $_POST['article']; // 메시지 function을 위한..

/* {{{ 쿠키 설정 */
$c_time = time() + 2592000;
setcookie('etchibbs_name', $cname,     $c_time);
setcookie('etchibbs_mail', $cemail,    $c_time);
setcookie('etchibbs_home', $chomepage, $c_time);
if ($cicon == 'none.jpg') {
    setcookie('etchibbs_icon', '');
} else {
    setcookie('etchibbs_icon', $cicon, $c_time);
}
/* }}} */

if(!strcmp($homepage, 'http://')) {
    $homepage = ''; // http://일 경우 홈페이지 비우기
}

mt_srand(microtime() * 1e6);
$passwd =& quote_string(crypt($_POST['passwd'], chr(mt_rand(0x21, 0x7E)) . chr(mt_rand(0x21, 0x7E))));
$now_date = date('Y/m/d H:i:s');
$user_agent =& quote_string($_SERVER['HTTP_USER_AGENT']);

$name     =& quote_string($name);
$email    =& quote_string($email);
$homepage =& quote_string($homepage);
$icon     =& quote_string($_POST['icon']);
$content  =& quote_string($_POST['ne']);

ignore_user_abort(TRUE);

// 커멘트 카운터 읽기/쓰기
$DBConn = new DBConnection;
$DBConn->begin(TRUE);
// SQLite does not support SELECT ... FOR UPDATE
$DBConn->exec("UPDATE hboard_db_article SET reply=reply+1 WHERE idx={$article_no}");
$cmtcount =& $DBConn->query("SELECT reply FROM hboard_db_article WHERE idx={$article_no}");

if (!$cmtcount) {
    delete($DBConn);
    DBConnectionFinish();
    trigger_error("{$article_no}번 게시물을 찾을 수 없습니다.<br />해당 게시물이 올바르게 등록되어 있는지 확인해 주세요.", E_USER_WARNING);
}
$DBConn->commit(TRUE);

$rno = (int) $cmtcount->getValue(0);

// 쓰기
$DBConn->exec("INSERT into hboard_db_comment
    (article, idx, name, email, home, icon, ipaddr, passwd, date, ment, agent) VALUES
    ({$article_no}, {$rno}, '{$name}', '{$email}', '{$homepage}', '{$icon}',
    '{$_SERVER['REMOTE_ADDR']}', '{$passwd}', '{$now_date}', '{$content}', '{$user_agent}')");

// 출력
$Layout = new Layout;

$MessageBox = new MessageBox;
$MessageBox->setTypeList((int) $_POST['page'], $article_no);
$MessageBox->registerTitle('안내');
$MessageBox->registerMessage("{$article_no}번 게시물에 의견을 추가하였습니다.");

$Layout->printHeader();
$MessageBox->printOut();
$Layout->printFooter();

?>
