<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: post_modify.php,v 1.36 2004/05/11 13:22:24 lseeker Exp $
 */

require 'lib/common.php';
require 'lib/article.basic.php';
require 'lib/article.write.php';

if (empty($_POST['article_no'])) trigger_error('수정할 게시물이 지정되지 않았습니다.', E_USER_WARNING);

$NewArticle = new ArticleWrite((int) $_POST['article_no']);

if (!$Config->checkAdmin) {
    $NewArticle->checkPassword();
    $NewArticle->writeCookie();
}

$NewArticle->checkFileSize($Config->filesize_max);
$NewArticle->checkFileType($Config->allow_filetype);
$NewArticle->checkFileMD5($Config->md5check);

$NewArticle->writeDB();

// 출력 준비
$Layout = new Layout;
$Layout->hideInclude();
$MessageBox = new MessageBox;
$MessageBox->setTypeList((int) $_POST['page'], $NewArticle->no);
$MessageBox->registerTitle('안내');
$MessageBox->registerMessage("{$NewArticle->no}번 게시물의 수정 작업을 완료했습니다.");

// 출력
$Layout->printHeader();
$MessageBox->printOut();
$Layout->printFooter();

?>
