<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: rss.php,v 1.15 2004/04/05 00:43:41 lseeker Exp $
 */

define('NO_HTML_HEADER', TRUE);
require 'lib/common.php';
require 'lib/article.basic.php';

// HEADER OUTPUT
header('Content-Type: application/rdf+xml; charset=UTF-8');

$listlink = $_SERVER['SERVER_NAME'] . str_replace('rss.php', 'list.php', $_SERVER['PHP_SELF']);
$viewlink = $_SERVER['SERVER_NAME'] . str_replace('rss.php', 'view.php?no=', $_SERVER['PHP_SELF']);

$title = empty($Config->html_title) ? 'EtchiBBS Spiral :: RSS' : $Config->html_title;

echo <<<RSSHEAD
<?xml version="1.0" encoding="UTF-8"?>
<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns="http://purl.org/rss/1.0/">
 <channel rdf:about="http://{$_SERVER['SERVER_NAME']}{$_SERVER['PHP_SELF']}">
  <title>{$title}</title>
  <link>http://{$listlink}</link>
  <description>
   EtchiBBS Spiral recent articles.
  </description>
 </channel>

RSSHEAD;

// GET RECENT ARTICLES INFO
/* TODO 필요한 정보만으로 정리 */
$DBConn = new DBConnection;
$Result =& $DBConn->query('SELECT * FROM hboard_db_article ORDER BY idx DESC LIMIT 20');

// No data
if (!$Result) {
    echo <<<NODATA
 <item rdf:about="http://{$listlink}">
  <title>NO DATA</title>
  <description>게시판에 글이 없습니다.</description>
 </item>
</rdf:RDF>

NODATA;
    exit;
}

$Article = new ArticleBasic;

do {
    $Article->attach($Result);
    if ($Article->deleted) {
        $subject = '삭제된 게시물입니다.';
        $content = '삭제된 게시물입니다.';
    } else {
        $subject = empty($Article->subject) ? '(제목 없음)' : htmlspecialchars($Article->subject);
        $content = nl2br(htmlspecialchars($Article->content));
    }

    echo <<<REPEAT
 <item rdf:about="http://{$viewlink}{$Article->no}">
  <title>{$subject}</title>
  <link>http://{$viewlink}{$Article->no}</link>
  <description><![CDATA[
   {$content}
  ]]></description>
 </item>

REPEAT;
} while ($Result->goNext());

// FOOT OUTPUT
?>
</rdf:RDF>

