<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: search.php,v 1.75 2004/05/11 18:57:45 lseeker Exp $
 */

require 'lib/common.php';
require 'lib/article.basic.php';
require 'lib/article.print.php';
include 'lib/list.class.php';

if (empty($_GET['word']) || empty($_GET['type'])) trigger_error('검색어 및 검색 방식을 입력해 주세요.', E_USER_WARNING);

$word = get_magic_quotes_gpc() ? stripslashes($_GET['word']) : $_GET['word'];
$type = $_GET['type'];

// 3바이트 (한글 1자) 체크
if (strlen($word) < 3) trigger_error('검색어가 너무 짧습니다.', E_USER_WARNING);

$allow_type = array('name' => 'name', 'subject' => 'subject', 'content' => 'ment', 'image' => 'cfile');

if (!isset($allow_type[$type])) trigger_error('적합하지 않은 검색 방식입니다', E_USER_WARNING);

$dbt = $allow_type[$type];
$dbw = str_replace('%', '\\\\%', quote_string($_GET['word']));

session_start();
$DBConn = new DBConnection;

// {{{검색 리스트 만들기
if (empty($_GET['page']) || !isset($_SESSION['search'][$type][$word])) {
    $List =& $DBConn->query("SELECT idx FROM hboard_db_article WHERE deleted<>'t' AND {$dbt} LIKE '%{$dbw}%' ORDER BY idx DESC");

    if (isset($_SESSION['search'][$type][$word])) unset($_SESSION['search'][$type][$word]);

    $_SESSION['search'][$type][$word] = array();

    if ($List) {
        do $_SESSION['search'][$type][$word][] = (int) $List->getValue(0);
        while ($index = $List->goNext());
    }

    delete($List);
}
// }}}

$total_article_num = count($_SESSION['search'][$type][$word]);
if (!$total_article_num) trigger_error('검색 결과가 없습니다.', E_USER_WARNING);

// {{{ 페이징 처리
$Paging = new Paging($total_article_num, $Config->app);
$end = $Paging->now_page * $Config->app - 1;
if ($end >= $total_article_num) $end = $total_article_num - 1;
$Paging->registerAddress("search.php?type={$type}&amp;word=" . rawurlencode($word) . '&amp;page=');
$Paging->hideStats();
// }}}

for ($i = ($Paging->now_page - 1) * $Config->app; $i <= $end; $i++) $list_in[] = $_SESSION['search'][$type][$word][$i];
if (!isset($list_in)) trigger_error('존재하지 않는 페이지입니다.', E_USER_WARNING);

// 리스트 설정
// {{{ ArticleList class for Search
class ArticleList extends ArticlePrint
{
    var $result;
    var $type = NULL;
    var $word = NULL;

    function ArticleList(&$Result)
    {
        $this->result =& $Result;
        $this->ArticlePrint();
    }

    function setHighlight(&$type, &$word)
    {
        $this->type =& $type;
        $this->word =& $word;
    }

    function highlight()
    {
        if ($this->type) {
            $type =& $this->type;
            $this->$type = str_replace($this->word, "<span class=\"fgSpc1 fontBold\">{$this->word}</span>", $this->$type);
        }
    }

    function printOut()
    {
        if (!$this->result) {
            trigger_error('검색 결과를 가져오지 못했습니다.', E_USER_NOTICE);
        } else {
            do {
                $this->attach($this->result);
                $this->outputPrepare();
                $this->highlight();
                $this->outputReal();
            } while ($this->result->goNext());
        }
    }
}
// }}}

$dbin = implode(',', $list_in);
$ArticleList = new ArticleList($DBConn->query("SELECT idx, name, email, home, ipaddr, date, cfile, subject, ment, deleted, reply, agent FROM hboard_db_article WHERE idx IN ({$dbin}) ORDER BY idx DESC"));
$ArticleList->setPageNum($Paging->now_page);
if ($type != 'image') $ArticleList->setHighlight($type, $word);

$type_str_list = array('name' => '작성자', 'subject' => '글 제목', 'content' => '글 내용', 'image' => '파일 이름');

// 도구상자 설정
$ToolBox = new ToolBox(
    "{$type_str_list[$type]}에 대한 검색어 <b>{$word}</b>(으)로 {$total_article_num}개의 결과가 검색되었습니다. [<a href=\"list.php\"><b>목록으로 돌아가기</b></a>]<br />현재 {$page} 페이지 / 전체 " . intval(($total_article_num + $Config->app - 1) / $Config->app) . " 페이지 (페이지당 {$Config->app}개씩 출력)",
    $Config->checkAdmin);

// 검색폼 설정
$SearchForm = new SearchForm($type, $word);

// 출력
$Layout = new Layout;

$Layout->printHeader();
echo "<script type=\"text/javascript\">\n<!--\nfunction show_comment_form(n) {\nreturn true;\n}\n//-->\n</script>";
$ToolBox->show();
$ArticleList->printOut();
$Paging->printOut();
$SearchForm->show();
echo '<p class="center fontBold">[<a href="list.php">목록으로 돌아가기</a>]</p>';
$Layout->printFooter();

?>
