<?php
/* vim600: et ts=4 sts=4 sw=4 fdm=marker
 *
 * EtchiBBS UTF-8 - Gallery Web Board
 * Copyright (C) 2004 EtchiBoard Project
 * 
 * See LICENSE for license condition.
 *
 * http://etchibbs.kldp.net
 * $Id: uninstall.php,v 1.22 2004/05/11 13:22:24 lseeker Exp $
 */

require 'lib/common.php';

$Config->checkAdmin();

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    // 비밀번호 확인
    if (empty($_POST['uninstall_password']) || crypt($_POST['uninstall_password'], $Config->password) != $Config->password) trigger_error('비밀번호가 올바르지 않습니다!', E_USER_WARNING);

    ignore_user_abort(TRUE);
    $Layout = new Layout;
    $Layout->hideInclude();
    $Layout->hideHeadText();

    $Layout->printHeader();
    echo '<h1 class="center">EtchiBBS 제거</h1>';

    // 데이터베이스 삭제
    $MessageBox = new MessageBox;
    $MessageBox->registerTitle('데이터베이스 삭제');

    $DBConn = new DBConnection;
    $msg = '의견글 테이블 삭제 ' . ($DBConn->exec('DROP TABLE hboard_db_comment', FALSE) ? '성공' : '실패') . '<br />';
    $msg .= '글 테이블 삭제 ' . ($DBConn->exec('DROP TABLE hboard_db_article', FALSE) ? '성공' : '실패') . '<br />';
    $msg .= '관리자 테이블 삭제 ' . ($DBConn->exec('DROP TABLE hboard_db_admin', FALSE) ? '성공' : '실패');
    $msg .= 'IP 차단 테이블 삭제 ' . ($DBConn->exec('DROP TABLE hboard_db_ipban', FALSE) ? '성공' : '실패');

    DBConnectionFinish();
    if (trim($_DBConnectionInfo[1]) == 'sqlite') unlink('db/' . trim($_DBConnectionInfo[5]) . '.db');

    $MessageBox->registerMessage($msg);
    $MessageBox->printOut();

    // 파일 삭제
    $MessageBox->registerTitle('파일 삭제');

    if ($diropen = opendir('db/ico/')) {
        while(false !== ($file = readdir($diropen))) { 
            if ($file != '.' && $file != '..') unlink('db/ico/' . $file);
        }
        closedir($diropen);
    }
    rmdir('db/ico');
    $msg = '아이콘 파일 삭제 완료<br />';

    if ($diropen = opendir('db/img/')) {
        while(false !== ($file = readdir($diropen))) { 
            if ($file != '.' && $file != '..') {
                unlink('db/img/' . $file);
                echo '.';
            }
        }
        closedir($diropen);
    }
    rmdir('db/img');
    $msg .= '이미지 파일 삭제 완료<br />';

    unlink('db/index.html');
    unlink('db/dbconn.php');
    $msg .= '기타 파일 삭제 완료';

    $MessageBox->registerMessage($msg);
    $MessageBox->printOut();

    // 완료 메세지
    $MessageBox->registerTitle('EtchiBBS 제거 완료');
    $MessageBox->registerMessage('<span class="fgSpc2">이제 <b>게시판 디렉토리를 삭제</b>하시면<br />완전히 제거됩니다.</span.</p>');
    $MessageBox->printOut();
    $Config->printFooter();

    exit;
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
 <title>EtchiBBS Uninstall :: Confirm</title>
 <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
 <link href="internal.css" rel="stylesheet" type="text/css">
 <script type="text/javascript">
<!--
function del_confirm(form) {
    if(form.uninstall_password.value == '') {
        alert('비밀번호가 비어 있습니다!');
        form.uninstall_password.focus();
        return false;
    }

    return true;
}
//-->
 </script>
</head>

<body>
<div id="login">
 <div id="logintop">
  <h1><span class="red">EtchiBBS 설치 제거: 경고</span></h1>
 </div>
 <p class="center">
 <strong>모든 게시물과 환경 설정이 삭제됩니다!</strong>
 <pre>
설치 제거(언인스톨)는 다음 요소들을 삭제할 것입니다.

- db 디렉토리 안의 모든 내용 (아이콘과 그림 파일 전부)
- hboard_db_article, hboar_db_admin, hboard_db_comment
  테이블 내의 모든 내용 (글 데이터와 관리자 환경 설정)

설치 제거 후에도 게시판 디렉토리는 보존됩니다.
(처음 게시판을 설치할 때와 같은 방법으로 재설치가 가능합니다)

게시판 설치 제거를 취소하시려면, 아래 비밀번호 입력칸 옆쪽에 위치한
"취소" 버튼을 클릭하셔서, 관리자 모드로 되돌아갈 수 있습니다.
</pre>
 </p>
 <form method="post" action="uninstall.php" onsubmit="return del_confirm(this);">
  <p class="center">
  <span class="blue">관리자 비밀번호</span>를 입력하신 후, [확인]을 누르시면 설치 제거를 시작합니다.
  </p>
  <p class="center">
  <label>비밀번호: <input type="password" name="uninstall_password" size="14" /></label>
  <input type="submit" value="확인" />
  <input type="button" value="취소" onclick="history.back();">
  </p>
 </form>
</div>
</body>
</html>

